#include <stdio.h>
#include "A_layout.h"

/* Virtual tables forward declaration */

static const VTABLE* const A_vtbl;

/*
 * Constructors and destructors
 */

void A_ctor(register A* const this, long a)
{
  this->vptr = A_vtbl;                  /* compiler */
  this->a = a;                          /* user     */

  print_layout("A", "ctor", this, sizeof *this);
}

void A_dtor(register A* const this)
{
  this->vptr = A_vtbl;                  /* compiler */
  this->a = 0;                          /* user     */

  print_layout("A", "dtor", this, sizeof *this);
}

/*
 * Member functions
 */

void A_f(register const A* const this)
{
  print_vfunc("A", "f", this, "a = %ld", this->a);
}


/* -- -- -- -- -- Compiler extra information -- -- -- -- -- */

/*
 * Runtime type information (RTTI)
 */

const type_info A_info[] = {{
  "A", 0, 0
}};

/*
 * Virtual tables
 */

static const VTABLE A_vtbl_[] = {
  0,                                    /* A->A       */
  (VTABLE)A_info,                       /* type_info  */
  (VTABLE)A_dtor,                       /* dtor       */
  (VTABLE)A_f                           /* f          */
};
static const VTABLE* const A_vtbl = A_vtbl_ + VSTART(NO_VBASE);

