#include <stdio.h>
#include "B_layout.h"

/* Virtual tables forward declaration */

static const VTABLE* const B_vtbl;

/*
 * Constructors and destructors
 */

void B_ctor(register B* const this, long b)
{
  this->vptr = B_vtbl;                  /* compiler */
  this->b = b;                          /* user     */

  print_layout("B", "ctor", this, sizeof *this);
}

void B_dtor(register B* const this)
{
  this->vptr = B_vtbl;                  /* compiler */
  this->b = 0;                          /* user     */

  print_layout("B", "dtor", this, sizeof *this);
}

/*
 * Member functions
 */

B* B_g(register B* const this)
{
  print_vfunc("B", "g", this, "b = %ld", this->b);

  return this;
}


/* -- -- -- -- -- Compiler extra information -- -- -- -- -- */

/*
 * Runtime type tnformation (RTTI)
 */

const type_info B_info[] = {{
  "B", 0, 0
}};

/*
 * Virtual tables
 */

static const VTABLE B_vtbl_[] = {
  0,                                    /* B->B       */
  (VTABLE)B_info,                       /* type_info  */
  (VTABLE)B_dtor,                       /* dtor       */
  (VTABLE)B_g                           /* g          */
};
static const VTABLE* const B_vtbl = B_vtbl_ + VSTART(NO_VBASE);
