#ifndef B_LAYOUT_H
#define B_LAYOUT_H

#include "object_model.h"

/* -----
 * NOTE: Layout of B
 * -----
 *
 * struct B {
 *   B(long b_);
 *   virtual ~B();
 *   virtual B* g();
 * protected:
 *   long b;
 * };
 *
 * -----
 */

/*
 * Instance layout
 */

typedef struct {
  const VTABLE *vptr;                   /* compiler */
  long b;                               /* B member */
} B;

/*
 * Member functions
 */

void B_ctor(B *this, long b);
void B_dtor(B *this);
B*   B_g   (B *this);


/* -- -- -- -- -- Compiler extra information -- -- -- -- -- */

/*
 * Virtual member functions
 */

enum {
  INDEX(B_dtor) = FIRST_VFUNC,
  INDEX(B_g   ) = AFTER_VFUNC(B_dtor)
};

typedef void (TYPE(B_dtor))(B*);
typedef B*   (TYPE(B_g   ))(B*);

/* -- -- -- -- -- Compiler exported symbols -- -- -- -- -- */

/*
 * Runtime Type Information (RTTI)
 */

extern const type_info B_info[];

#endif /* B_LAYOUT_H */
