#ifndef D_LAYOUT_H
#define D_LAYOUT_H

#include "object_model.h"

/* -----
 * NOTE: Layout of D
 * -----
 *
 * struct D {
 *   D(long d_);
 *   ~D();
 *   void k() const;
 *   protected: long d;
 * };
 *
 * -----
 */

/*
 * Instance layout
 */

typedef struct {
  long d;                               /* D member */
} D;

/*
 * Member functions
 */

void D_ctor(D *this, long d);
void D_dtor(D *this);
void D_k   (const D *this);


/* -- -- -- -- -- Compiler exported symbols -- -- -- -- -- */

/*
 * Runtime Type Information (RTTI)
 */

extern const type_info D_info[];

#endif /* D_LAYOUT_H */
