#include <iostream>

#include "object_model.hpp"

static bool do_print_layout = 0;

void
print_layout_flag(bool do_it)
{
  do_print_layout = do_it;
}

void
print_layout(const char *cls, const char *func,
	     void *p_this, size_t size)
{
  int i, cnt = size/sizeof(long);
  long *p = static_cast<long*>(p_this);

  if (!do_print_layout)
    return;

  if (size % sizeof(long) > 0) {
    std::cerr << "\tinvalid integral type 'long' for layout\n";
    return;
  }

 std::cout << cls << "::" << func
	  << " layout @ " << (unsigned long)p
	  << " : " << size << " bytes\n";

  for (i = 0; i < cnt; i++)
    std::cout << "\t[" << i << "]=" << p[i] << std::endl;
}
